# button_up.py v0.3 JFB 15/01/25, 18/01/25
# essai d'implementer l'algo BUTTON-UP cree par Dilly Knox
# pour trouver le cablage d'une Enigma commerciale (sans stecker)

import string
import sys
import getopt
import re

def incoherence( une_hypothese ):
    let1 = une_hypothese[0]
    let2 = une_hypothese[1]

    for hyp in PILE_DEJA_TESTE + PILE_HYP:
        if une_hypothese in PILE_DEJA_TESTE + PILE_HYP:
            continue
        c1 = hyp[0]
        c2 = hyp[1]
        if (let1 == c1 or let2 == c2):
            return True
    return False

def recherche(un_couple, colone_depart):
    let1 = un_couple[0]
    let2 = un_couple[1]
    if DEBUG:
        print("Start column, max: ", colone_depart, MAX_LG)
    col_sortie = -1   # reste a cette valeur, si on ne trouve rien
    for une_colone in range(colone_depart, MAX_LG-1):
        if DEBUG:
            print("Current column (1): ", une_colone, 
                " let1,let2: ", let1, let2)
        # --- recherche couple pour 1er lettre
        for autre_couple in TABLE_II[une_colone]:
            #print("col, autre_couple: ", une_colone, autre_couple)
            c1 = autre_couple[0]
            c2 = autre_couple[1]
            if DEBUG:
                print("Scan the other column (2): ", autre_couple)
            if let1 == c1 or let1 == c2:
                if let1 == c1:
                    hyp_1 = c2
                else:
                    hyp_1 = c1
                # --- recherche couple pour 2ieme lettre
                #     (dans la colonne suivante)
                for couple_deux in TABLE_II[une_colone+1]:
                    cc1 = couple_deux[0]
                    cc2 = couple_deux[1]
                    if DEBUG:
                        print(c1,c2,cc1,cc2,une_colone)
                    if let2 == cc1 or let2 == cc2:
                        if let2 == cc1:
                            hyp_2 = cc2
                        else:
                            hyp_2 = cc1
                        une_hypo = hyp_1 + hyp_2
                        col_sortie =une_colone
                        return une_hypo, une_colone
    return "", col_sortie

def new_couples(couples):
    if DEBUG: print(couples)
    nouveau_couple = []
    i = 0
    for un_couple in couples:
        x = un_couple[0]
        y = un_couple[1]
        pos1 = QWERTZU.find(x)
        pos2 = QWERTZU.find(y)
        plain = QWERTZU[(pos1+i)%26]
        crypto= QWERTZU[(pos2+i)%26]
        if pos1 == -1 or pos2 == -1:
            print("ERROR: letter not found");exit(1)
        if plain < crypto:
            new_cpl = plain + crypto
        else:
            new_cpl = crypto + plain
        if DEBUG:
            print("%s" % (new_cpl), end=",")
        TABLE_I[i].append(un_couple)
        TABLE_2[i].append(new_cpl)
        i += 1
    if DEBUG: print()

def lit_fichier(nom):
    if DEBUG:
        print("--lit fichier--")
    f = open(nom)
    lignes = []
    while True:
        ch = f.readline()
        if ch == "": break
        lignes.append(ch.upper())
    if DEBUG:
        for une_ligne in lignes:
            print(">>>", une_ligne.rstrip())
    flag_wait_plain = True
    flag_wait_crypto = False 
    i = 0
    while True:
        if i == len(lignes):
            break
        if DEBUG:
            print("i,ligne-->", i, lignes[i])
        if lignes[i][0] not in ALPHA:
            i += 1
            continue
        if flag_wait_plain:
            plain = lignes[i]
            flag_wait_plain = False
            flag_wait_crypto = True
            i += 1
        elif flag_wait_crypto:
            crypto = lignes[i]
            flag_wait_plain = True
            flag_wait_crypto = False
            lst_couples = []
            match = re.search("[A-Z]+", plain)
            if match:
                plain = match.group()
            match = re.search("[A-Z]+", crypto)
            if match:
                crypto = match.group()
            for j in range(len(plain)):
                lst_couples.append( plain[j] + crypto[j] )
            MSGS.append( list(lst_couples))
            i += 1
        
    if len(MSGS) == 0:
        print("--- Data File empty  ---")
        exit(1)


def usage():
    print("Usage:")
    print("Syntaxe: button_up.py -F data.txt")
    print("         the Internal Key file need to end by .key")
    print("Options:")
    print("  -h       Help")
    print("  -d       Debug mode")
    print("  -o       One Shot (we test only one hypothesis)")
    print("           False by default")
    print("  -F file  The file which contains plain and crypto")
    print("  -T TO    The Turnover position, 0 by default")
    print("  -Q ETW   The wiring of enter disk (Qwertzu)")
    print("           ETW is a string of 26 letters or")
    print("           the word QWE for the ETW of the commercial")
    print("           Enigma, the word ABC for the ETW of ")
    print("           military Enigma. QWE by default")
    print("  -H hyp   The starting hypothesis, AB by default")
#======================================
try:
  if len(sys.argv) == 1:
    raise getopt.GetoptError("too few arguments")
  opts, args = getopt.getopt(sys.argv[1:],
    "hoF:dT:Q:H:", ["help","oneshot","file=","debug","turnover=",
    "qwertzu=","sthypo=" ])
except getopt.GetoptError as err:
  # print help information and exit:
  print(sys.argv[0],": ", str(err))# option -a not recognized"
  usage()
  sys.exit(2)

QWERTZU = "QWERTZUIOASDFGHJKPYXCVBNML"
ALPHA = string.ascii_uppercase
DEBUG = False
TURNOVER = 0
MSGS = []
TABLE_I = [[] for _ in range(26)]
TABLE_2 = [[] for _ in range(26)]
TABLE_II= [[] for _ in range(26)]
START_HYP = "AB"
ONE_SHOT = False

for o, a in opts:
  if   o in ("-d", "--debug"):
    DEBUG = True
  elif o in ("-h", "--help"):
    usage()
    sys.exit()
  elif o in ("-o", "--oneshot"):
    ONE_SHOT = True
  elif o in ("-F", "--file"):
    DATA_FILE = a
  elif o in ("-T", "--turnover"):
    TURNOVER = int(a)
  elif o in ("-Q", "--quertzu"):
    if (a == "ABC"):
        QWERTZU = ALPHA
    elif (a == "QWE"):
        None
    elif (len(a) == 26):
        QWERTZU = a
    else:
        print("Qwertzu too short")
        exit(1)
  elif o in ("-H", "--sthypo"):
        START_HYP = a
  else:
    assert False, "unhandled option"

try:
    DATA_FILE
except NameError:
    print("The Data File must be given")
    exit(1)
#------------------------------------------
if DEBUG:
    print("Mode Debug: ", DEBUG)
    print("Qwertzu: ", QWERTZU)
    print("Turnover: ", TURNOVER)
    print("Data file: ", DATA_FILE)
    print("Starting Hypothesis: ", START_HYP)
lit_fichier(DATA_FILE)
if DEBUG:
    print("MSGS: ", MSGS)
for un_msgs in MSGS:
    new_couples(un_msgs)

print("Table I:")
for i in range(len(TABLE_I)):
    print("%2d - " % (i), end="")
    for j in range(len(TABLE_I[i])):
        un_couple = TABLE_I[i][j]
        if type(un_couple) != str: break
        print(un_couple,end=":")
    print()
    if len(TABLE_I[i]) == 0: break

TABLE_II = []
for i in range(len(TABLE_2)):
    TABLE_II.append([])
    for j in range(len(TABLE_2[i])):
        un_couple = TABLE_2[i][j]
        if un_couple not in TABLE_II[i]:
            TABLE_II[i].append(un_couple)
    if len(TABLE_2[i]) == 0: break
for i in range(len(TABLE_II)-1,0,-1):
    if len(TABLE_II[i]) == 0: 
        TABLE_II.pop()

print("Table II:")
for i in range(len(TABLE_II)):
    print("%2d - " % (i), end="")
    for j in range(len(TABLE_II[i])):
        un_couple = TABLE_II[i][j]
        if type(un_couple) != str: break
        print(un_couple,end=":")
    print()
    if len(TABLE_II[i]) == 0: break

MAX_LG = len(TABLE_II)
print("Number of column ", MAX_LG)

#================= grande boucle sur les differentes hypotheses ===
LET1 = START_HYP[0]
LET2 = START_HYP[1]

for idx in range(26):
    let2_suivante = chr(ord('A')+((ord(LET2)-ord('A'))+idx)%26)
    hypo_initiale = LET1 + let2_suivante

    #---------- on part de l'hypothese
    PILE_HYP = []    # la pile d'hypotheses
    PILE_HYP.append( hypo_initiale )
    PILE_DEJA_TESTE = []
    print("========> Initial Hyptothesis: ", hypo_initiale)
    FLAG_INCOHERENCE = False
    
    while True:
        # --- on sort si la Pile est vide
        if len(PILE_HYP) == 0: 
            if DEBUG:
                print("---Stack Empty---")
            break
    
        # --- on extrait une hypothese en FIFO
        #     on verifie que on ne l'a pas deja testée
        CURRENT_HYP = PILE_HYP.pop(0)
        n = PILE_DEJA_TESTE.count( CURRENT_HYP )
        if n != 0:
            continue
        if DEBUG:
            print("Current Hypothesis: ", CURRENT_HYP)
    
        # --- recherche de nouvelles hypothese
        colone = 0
        while True:
            # === Rechercher une nouvelle hypothese
            A_NEW_HYPO, colone  = recherche( CURRENT_HYP, colone)
    
            # === Si c'etait la dernieree hypothses possible, on sort
            if A_NEW_HYPO == "": 
                if DEBUG:
                    print("--- No more hypotheses available ---", colone)
                break
    
            # === Est-ce qu'il y a une incoherence?
            if incoherence( A_NEW_HYPO ):
                print("Incoherence, hyp, new: ",CURRENT_HYP, A_NEW_HYPO)
                FLAG_INCOHERENCE = True
                if DEBUG:
                    print(PILE_HYP + PILE_DEJA_TESTE)
                break
    
            # === Est-ce que la nouvelle hypothese existe deja?
            if A_NEW_HYPO not in PILE_DEJA_TESTE \
                and A_NEW_HYPO not in PILE_HYP:
                if DEBUG:
                    print("===> A new deduction: ", A_NEW_HYPO,
                        " colone: ", colone)
                PILE_HYP.append( A_NEW_HYPO )
            else:
                if DEBUG:
                    print("Already exists: ", A_NEW_HYPO)
    
            colone += 1
            if colone == MAX_LG:
                print("--- the last column, we exit the loop: ", colone)
                break
    
        # --- on considere que l'hypothese a ete testée
        PILE_DEJA_TESTE.append( CURRENT_HYP )
        if DEBUG:
            print("--- PAIRS TO BE TESTED  : ", PILE_HYP)
            print("--- PAIRS ALREADY TESTED: ", PILE_DEJA_TESTE)
        if FLAG_INCOHERENCE:
            break
    
    print("Deductions: ", PILE_DEJA_TESTE)
    if ONE_SHOT:
        break

